package com.gzlh.background.client;

import com.gzlh.background.client.CustomHeartbeatHandler;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.timeout.IdleStateEvent;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@ChannelHandler.Sharable
public class BackgroundClientHandler extends CustomHeartbeatHandler {
    private BackgroundClientNetty client;

    public BackgroundClientHandler(BackgroundClientNetty client) {
        super("client");
        this.client = client;
    }


//    @Override
//    protected void channelRead0(ChannelHandlerContext ctx, String msg) throws Exception {
//        System.out.println(1111);
//        System.out.println("Client received: " + msg);
//
//    }


    //    @Override
//    public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {
//        System.out.println(1111);
//        System.out.println(msg);
////        ByteBuf in = (ByteBuf) msg;
////        System.out.println("Client received: " + in.toString(CharsetUtil.UTF_8));
//
//    }

    @Override
    protected void handleData(ChannelHandlerContext channelHandlerContext, String msg) {
//        byte[] data = new byte[byteBuf.readableBytes() - 5];
//        byteBuf.skipBytes(5);
//        byteBuf.readBytes(data);
//        String content = new String(data);
        System.out.println(name + " get content: " + msg);
    }

    @Override
    protected void handleAllIdle(ChannelHandlerContext ctx) {
        super.handleAllIdle(ctx);
        sendPingMsg(ctx);
    }


//    @Override
//    public void channelActive(ChannelHandlerContext ctx) throws Exception {
//        //当被通知Channel是活跃的时候，发送一条消息
////        ctx.writeAndFlush(Unpooled.copiedBuffer("Netty rocks!", CharsetUtil.UTF_8));
////        sendPingMsg(ctx);
//    }

    @Override
    public void userEventTriggered(ChannelHandlerContext ctx, Object evt) throws Exception {
        // IdleStateHandler 所产生的 IdleStateEvent 的处理逻辑.
        if (evt instanceof IdleStateEvent) {
            IdleStateEvent e = (IdleStateEvent) evt;
            switch (e.state()) {
                case READER_IDLE:
                    handleReaderIdle(ctx);
                    break;
                case WRITER_IDLE:
                    handleWriterIdle(ctx);
                    break;
                case ALL_IDLE:
                    handleAllIdle(ctx);
                    break;
                default:
                    break;
            }
        }
    }


    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
        cause.printStackTrace();
        ctx.close();
    }

    @Override
    public void channelInactive(ChannelHandlerContext ctx) throws Exception {
        super.channelInactive(ctx);
        client.connect();
    }

}
