package com.gzlh.hksdk;

import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.CommandLineRunner;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

@Data
@Slf4j
@Order(99)
@Component
public class StartUpInit implements CommandLineRunner {

    @Resource
    private HkUtils hkUtils;
    @Resource
    private HCNetSDK hcNetSDK;

    @Override
    public void run(String... args)   {
        short port=8000;
        int userId = hkUtils.Login_V40("192.168.1.11", port, "admin", "ap123456", hcNetSDK);
        log.info("user id:{}",userId);
        log.info("登录海康设备:{},{}",hcNetSDK.NET_DVR_GetLastError(),userId);
        hkUtils.handlerUp(hcNetSDK,userId);
        log.info("海康抬杆设备:{},{}",hcNetSDK.NET_DVR_GetLastError(),userId);
    }
}
